
// IdentificationDlg.cpp : implementation file
//--------------------------------------------
#include "stdafx.h"
#include "PCAcceptor.h"
#include "IdentificationDlg.h"
#include "PCAcceptorDlg.h"
#include "Swap.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CIdentificationDlg dialog
//--------------------------

CIdentificationDlg::CIdentificationDlg(CWnd* pParent) : CDialog(CIdentificationDlg::IDD, pParent)
//===============================================================================================
{
	//{{AFX_DATA_INIT(CIdentificationDlg)
	m_strManufacturerCode = _T("");
	m_strModelNumber = _T("");
	m_strSerialNumber = _T("");
	m_strSoftwareVersion = _T("");
	m_strFeature1 = _T("");
	m_strFeature2 = _T("");
	m_strFeature3 = _T("");
	m_strFeature4 = _T("");
	//}}AFX_DATA_INIT
}

void CIdentificationDlg::DoDataExchange(CDataExchange* pDX)
//=========================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIdentificationDlg)
	DDX_Text(pDX, IDC_MANUFACTURER_CODE, m_strManufacturerCode);
	DDX_Text(pDX, IDC_MODEL_NUMBER, m_strModelNumber);
	DDX_Text(pDX, IDC_SERIAL_NUMBER, m_strSerialNumber);
	DDX_Text(pDX, IDC_SOFTWARE_VERSION, m_strSoftwareVersion);
	DDX_Text(pDX, IDC_OPT_FEATURE_1, m_strFeature1);
	DDX_Text(pDX, IDC_OPT_FEATURE_2, m_strFeature2);
	DDX_Text(pDX, IDC_OPT_FEATURE_3, m_strFeature3);
	DDX_Text(pDX, IDC_OPT_FEATURE_4, m_strFeature4);
	//}}AFX_DATA_MAP
}

void CIdentificationDlg::WordToBCD(WORD wValue, char* pstrBCD)
//============================================================
{
	sprintf(pstrBCD,_T("%u%u.%u%u"),((BYTE)(wValue>>12))&0x0F,((BYTE)(wValue>>8))&0x0F,((BYTE)(wValue>>4))&0x0F,((BYTE)wValue)&0x0F);
}


BEGIN_MESSAGE_MAP(CIdentificationDlg, CDialog)
	//{{AFX_MSG_MAP(CIdentificationDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CIdentificationDlg message handlers
//------------------------------------

BOOL CIdentificationDlg::OnInitDialog() 
//=====================================
{
	CDialog::OnInitDialog();
	CPCAcceptorDlg* pParent=(CPCAcceptorDlg*)GetParent();
	ACCEPTOR_IDENTIFICATION* pAcceptorIdentification=pParent->GetIdentification();
	m_strManufacturerCode=pAcceptorIdentification->strManufacturerCode;
	m_strSerialNumber=pAcceptorIdentification->strSerialNumber;
	m_strModelNumber=pAcceptorIdentification->strModelNumber;
	WordToBCD(SwapWORD(pAcceptorIdentification->wSoftwareVersion),m_strSoftwareVersion.GetBuffer(16));
	if ((SwapDWORD(pAcceptorIdentification->dwOptinalFeatures)&0x00000001)!=0)
	{
		m_strFeature1=_T("Enabled");
	}
	else
	{
		m_strFeature1=_T("Disabled");
	}
	if ((SwapDWORD(pAcceptorIdentification->dwOptinalFeatures)&0x00000002)!=0)
	{
		m_strFeature2=_T("Enabled");
	}
	else
	{
		m_strFeature2=_T("Disabled");
	}
	if ((SwapDWORD(pAcceptorIdentification->dwOptinalFeatures)&0x00000004)!=0)
	{
		m_strFeature3=_T("Enabled");
	}
	else
	{
		m_strFeature3=_T("Disabled");
	}
	if ((SwapDWORD(pAcceptorIdentification->dwOptinalFeatures)&0x00000008)!=0)
	{
		m_strFeature4=_T("Enabled");
	}
	else
	{
		m_strFeature4=_T("Disabled");
	}
	UpdateData(false);
	return TRUE;
}
