
// 
// Copyright (C)2003..2004 by BonusData AG, 
// Tiergartenweg 1, CH-4710 Balsthal, Switzerland.
// -----------------------------------------------
// Phone:	+41 62 3919600 
// Fax:		+41 62 3919601
// E-Mail:  team@bonusdata.net
// WEB:		http://www.bonusdata.net
//------------------------------------------------ 

#if !defined(__MDBDEFINES_H__)
#define __MDBDEFINES_H__

// MDB.h : header file
//--------------------
#define MDB_PROJECT_VERSION			0x0100
#define MAX_FRAME_LENGTH			36
#define MAX_SERIAL_NUMBER			12    
#define MAX_MODEL_NUMBER			12
#define MAX_MANUFACTURER			3
#define MAX_DISPLAY_DATA			32
#define MDB_BLOCK_SIZE				31

// MDB device address
//-------------------
#define ADR_MASTER					0x00
#define ADR_CHANGER					0x08
#define ADR_READER					0x10
#define ADR_BILL					0x30

// MDB command definition
//-----------------------
#define CMD_RESET					0x00
#define CMD_SETUP					0x01
#define CMD_STATUS					0x01
#define CMD_POLL					0x02
#define CMD_TUBE_STATUS				0x02
#define CMD_SECURITY				0x02
#define CMD_VEND					0x03
#define CMD_CHANGER_POLL			0x03
#define CMD_BILL_POLL				0x03
#define CMD_READER					0x04
#define CMD_COIN_TYPE				0x04
#define CMD_BILL_TYPE				0x04
#define CMD_REVALUE					0x05
#define CMD_ESCROW					0x05
#define CMD_DISPENSE				0x05
#define CMD_STACKER					0x06
#define CMD_EXPANSION				0x07
#define CMD_NO_PENDING				0xFF

// MDB sub command definition
//---------------------------
#define SUB_CONFIG_DATA				0x00
#define SUB_MAX_MIN_PRICE			0x01
#define SUB_VEND_REQUEST			0x00
#define SUB_VEND_CANCEL				0x01
#define SUB_VEND_SUCCESS			0x02
#define SUB_VEND_FAILURE			0x03
#define SUB_VEND_SESSION_COMPLETE	0x04
#define SUB_VEND_CASH_SALE			0x05
#define SUB_NEGATIVE_VEND_REQUEST	0x06
#define SUB_READER_DISABLE			0x00
#define SUB_READER_ENABLE			0x01
#define SUB_READER_CANCEL			0x02
#define SUB_REVALUE_REQUEST			0x00
#define SUB_REVALUE_LIMIT_REQUEST	0x01
#define SUB_REQUEST_ID				0x00
#define SUB_READ_USER_FILE			0x01
#define SUB_WRITE_USER_FILE			0x02
#define SUB_WRITE_TIME_DATE			0x03
#define SUB_CHANGER_IDENTIFICATION	0x00
#define SUB_FEATURE_ENABLE			0x01
#define SUB_ALTERNATIVE_PAYOUT		0x02
#define SUB_ALT_PAYOUT_STATUS		0x03
#define SUB_PAYOUT_VALUE_POLL		0x04
#define SUB_DIAGNOSTIC_STATUS		0x05
#define SUB_MANUAL_FILL_REPORT		0x06
#define SUB_MANUAL_PAYOUT_REPORT	0x07
#define SUB_IDENTIFICATION			0x00
#define SUB_IDENTIFICATION_2		0x02
#define SUB_READER_FEATURE_ENABLE   0x04
#define SUB_CHANGER_FEATURE_ENABLE	0x01
#define SUB_BILL_FEATURE_ENABLE		0x01
#define SUB_FTL_REQ_TO_RCV			0xFA
#define SUB_FTL_RETRY_DENY			0xFB
#define SUB_FTL_SEND_BLOCK			0xFC
#define SUB_FTL_OK_TO_SEND			0xFD
#define SUB_FTL_REQ_TO_SEND			0xFE
#define SUB_DIAGNOSTICS				0xFF

// MDB response definition
//------------------------
#define RSP_ACK						0x00
#define RSP_NAK						0xFF
#define RSP_RET						0xAA
#define RSP_JUST_RESET				0x00
#define RSP_MAX_MIN_PRICE			0x01
#define RSP_READER_CONFIG_DATA		0x01
#define RSP_DISPLAY_REQUEST			0x02
#define RSP_BEGIN_SESSION			0x03
#define RSP_SESSION_CANCEL_REQUEST	0x04
#define RSP_VEND_APPROVED			0x05
#define RSP_VEND_DENIED				0x06
#define RSP_END_SESSION				0x07
#define RSP_CANCELLED				0x08
#define RSP_PERIPHERAL_ID			0x09
#define RSP_MALFUNCTION_ERROR		0x0A
#define RSP_CMD_OUT_OF_SEQUENCE		0x0B
#define RSP_BUSY					0x0C
#define RSP_REVALUE_APPROVED		0x0D
#define RSP_REVALUE_DENIED			0x0E
#define RSP_REVALUE_LIMIT_AMOUNT	0x0F
#define RSP_USER_FILE_DATA			0x10
#define RSP_TIME_DATE_REQUEST		0x11
#define RSP_DATA_ENTRY_REQUEST		0x12
#define RSP_DATA_ENTRY_CANCEL		0x13
#define RSP_FTL_REQ_TO_RCV			0x1B
#define RSP_FTL_RETRY_DENY			0x1C
#define RSP_FTL_SEND_BLOCK			0x1D
#define RSP_FTL_OK_TO_SEND			0x1E
#define RSP_FTL_REQ_TO_SEND			0x1F
#define RSP_DIAGNOSTIC_RESPONSE		0xFF
#define RSP_NOTHING					0xEE // For internal use only

#pragma pack(push)
#pragma pack(1)

typedef struct tag_JUST_RESET
//===========================
{
	BYTE	RSP_Command;
} 
JUST_RESET;

typedef struct tag_CONFIG_DATA
//============================
{
	BYTE	SUB_Command;
	BYTE	FutureLevel;
	BYTE	ColumnsOnDisplay;
	BYTE	RowsOnDisplay;
	BYTE	DisplayInfo;
}
CONFIG_DATA;

typedef struct tag_READER_CONFIG_DATA
//===================================
{
	BYTE	RSP_Command;
	BYTE	FeatureLevel;
	WORD	CountryCode;
	BYTE	ScaleFactor;
	BYTE	DecimalPlaces;
	BYTE	MaximumResponseTime;
	BYTE	MiscellaneousOptions;
}
READER_CONFIG_DATA;

typedef struct tag_MIN_MAX_PRICES
//===============================
{
	BYTE	SUB_Command;
	WORD	MaximumPrice;
	WORD	MinimumPrice;
}
MIN_MAX_PRICES;

typedef struct tag_BEGIN_SESSION_1
//================================
{
	BYTE	RSP_Command;
	WORD	FundsAvailable;
}
BEGIN_SESSION_1;

typedef struct tag_BEGIN_SESSION_2
//================================
{
	BYTE	RSP_Command;
	WORD	FundsAvailable;
	DWORD	PaymentMediaID;
	BYTE	PaymentType;
	WORD	PaymentData;
}
BEGIN_SESSION_2;

typedef struct tag_SESSION_CANCEL_REQUEST
//=======================================
{
	BYTE	RSP_Command;
}
SESSION_CANCEL_REQUEST;

typedef struct tag_VEND_REQUEST
//=============================
{            
	BYTE	SUB_Command;
	WORD	ItemPrice;
	WORD	ItemNumber;
}
VEND_REQUEST;

typedef struct tag_VEND_APPROVED
//==============================
{             
	BYTE	RSP_Command;
	WORD	VendAmount;	
}
VEND_APPROVED;

typedef struct tag_VEND_SUCCESS
//=============================
{            
	BYTE	SUB_Command;
	WORD	ItemNumber;
}
VEND_SUCCESS;

typedef struct tag_END_SESSION
//============================
{
	BYTE	SUB_Command;
}
END_SESSION;

typedef struct tag_CANCELLED
//==========================
{
	BYTE	SUB_Command;
}
CANCELLED;

typedef struct tag_REQUEST_ID
//===========================
{
	BYTE	SUB_Command;
	BYTE	ManufacturerCode[3];
	BYTE	SerialNumber[12];
	BYTE	ModelNumber[12];
	WORD	SoftwareVersion;
}
REQUEST_ID;

typedef struct tag_PERIPHERAL_ID
//==============================
{
	BYTE	RSP_Command;
	BYTE	ManufacturerCode[3];
	BYTE	SerialNumber[12];
	BYTE	ModelNumber[12];
	WORD	SoftwareVersion;
}
PERIPHERAL_ID;    

typedef struct tag_REVALUE_REQUEST
//================================
{
	BYTE	SUB_Command;
	WORD	RevalueAmount;
}
REVALUE_REQUEST;

typedef struct tag_REVALUE_LIMIT_AMOUNT
//=====================================
{             
	BYTE	RSP_Command;
	WORD	RevalueLimit;
}
REVALUE_LIMIT_AMOUNT;

typedef struct tag_DISPLAY_REQUEST
//================================
{               
	BYTE	RSP_Command;
	BYTE	DisplayTime;
	BYTE	DisplayData[32];
}
DISPLAY_REQUEST;

typedef struct tag_ACCEPTOR_STATUS
//================================
{
	BYTE	FeatureLevel;
	WORD	CurrencyCode;
	BYTE	ScalingFactor;
	BYTE	DecimalPlaces;
	WORD	CoinTypeRouting;
	BYTE	CoinTypeCredit[16];
}
ACCEPTOR_STATUS;

typedef struct tag_ACCEPTOR_IDENTIFICATION
//========================================
{
	char	strManufacturerCode[16]; // Actual 3 bytes plus null terminated
	char	strSerialNumber[16]; // Actual 12 bytes plus null terminated
	char	strModelNumber[16]; // Actual 12 bytes plus null terminated
	WORD	wSoftwareVersion;
	DWORD	dwOptinalFeatures;
}
ACCEPTOR_IDENTIFICATION;

typedef struct tag_ACCEPTOR_TUBESTATUS
//====================================
{
	WORD	wTubeFullStatus;
	BYTE	TubeStatus[16];
}
ACCEPTOR_TUBESTATUS;

typedef struct tag_ACCEPTOR_DIAGNOSTIC_STATUS
//===========================================
{
	BYTE	PoweringUp;
	BYTE	PoweringDown;
	BYTE	Ready;
	BYTE	KeypadShifted;
	BYTE	ManualFillPayout;
	BYTE	InventoryAvailable;
	BYTE	Inhibited;
	BYTE	ChangerError;
	BYTE	DiscriminatorError;
	BYTE	AcceptorError;
	BYTE	SeparatorError;
	BYTE	DispenserError;
	BYTE	CasetteError;
	BYTE	UnknownStatus;
}
ACCEPTOR_DIAGNOSTIC_STATUS;

typedef struct tag_FTL_REQ_TO_RCV
//===============================
{
	BYTE	Command;
	BYTE	Destination;
	BYTE	Source;
	BYTE	FileNumber;
	BYTE	MaxBlocks;
	BYTE	Control;
}
FTL_REQ_TO_RCV;

typedef struct tag_FTL_RETRY_DENY
//===============================
{
	BYTE	Command;
	BYTE	Destination;
	BYTE	Source;
	BYTE	Retry;
}
FTL_RETRY_DENY;

typedef struct tag_FTL_SEND_BLOCK
//===============================
{
	BYTE	Command;
	BYTE	Destination;
	BYTE	BlockNumber;
	BYTE	Data[31];
}
FTL_SEND_BLOCK;

typedef struct tag_FTL_OK_TO_SEND
//===============================
{
	BYTE	Command;
	BYTE	Destination;
	BYTE	Source;
}
FTL_OK_TO_SEND;

typedef struct tag_FTL_REQ_TO_SEND
//================================
{
	BYTE	Command;
	BYTE	Destination;
	BYTE	Source;
	BYTE	FileNumber;
	BYTE	MaxBlocks;
	BYTE	Control;
}
FTL_REQ_TO_SEND;

typedef struct tag_FTL_TRANSFER_BUFFER
//====================================
{
	DWORD	dwDestination;
	DWORD	dwSource;
	DWORD	dwFileNumber;
	DWORD	dwMaxBlocks;
	DWORD	dwFileSize;
	DWORD	dwFileOffset;
	DWORD	dwBlockCount;
	BYTE	Data[MDB_BLOCK_SIZE*256];
}
FTL_TRANSFER_BUFFER;

#pragma pack(pop)

#endif // __MDBDEFINES_H__
